#line 1 "C:/Users/richard/Desktop/WORKDIR/Skywire/example/PIC/Skywire_PIC.c"
#line 1 "c:/users/richard/desktop/workdir/skywire/library/at_engine/at_engine.h"
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for pic/include/stdint.h"




typedef signed char int8_t;
typedef signed int int16_t;
typedef signed long int int32_t;


typedef unsigned char uint8_t;
typedef unsigned int uint16_t;
typedef unsigned long int uint32_t;


typedef signed char int_least8_t;
typedef signed int int_least16_t;
typedef signed long int int_least32_t;


typedef unsigned char uint_least8_t;
typedef unsigned int uint_least16_t;
typedef unsigned long int uint_least32_t;



typedef signed char int_fast8_t;
typedef signed int int_fast16_t;
typedef signed long int int_fast32_t;


typedef unsigned char uint_fast8_t;
typedef unsigned int uint_fast16_t;
typedef unsigned long int uint_fast32_t;


typedef signed int intptr_t;
typedef unsigned int uintptr_t;


typedef signed long int intmax_t;
typedef unsigned long int uintmax_t;
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for pic/include/stddef.h"




typedef int ptrdiff_t;
typedef int ptrdiffram_t;
typedef long int ptrdiffrom_t;


typedef unsigned int size_t;
typedef unsigned int sizeram_t;
typedef unsigned long int sizerom_t;


typedef unsigned char wchar_t;
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for pic/include/string.h"





void * memchr(void *p, char n, unsigned int v);
int memcmp(void *s1, void *s2, int n);
void * memcpy(void * d1, void * s1, int n);
void * memmove(void * to, void * from, int n);
void * memset(void * p1, char character, int n);
char * strcat(char * to, char * from);
char * strchr(char * ptr, char chr);
int strcmp(char * s1, char * s2);
char * strcpy(char * to, char * from);
int strlen(char * s);
char * strncat(char * to, char * from, int size);
char * strncpy(char * to, char * from, int size);
int strspn(char * str1, char * str2);
char strcspn(char * s1, char * s2);
int strncmp(char * s1, char * s2, char len);
char * strpbrk(char * s1, char * s2);
char * strrchr(char *ptr, char chr);
char * strstr(char * s1, char * s2);
char * strtok(char * s1, char * s2);
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for pic/include/stdbool.h"



 typedef char _Bool;
#line 23 "c:/users/richard/desktop/workdir/skywire/library/at_engine/at_engine.h"
typedef void ( *at_cmd_cb )( char *buffer );
#line 33 "c:/users/richard/desktop/workdir/skywire/library/at_engine/at_engine.h"
typedef void ( *at_write_p )( unsigned char data_out );
#line 40 "c:/users/richard/desktop/workdir/skywire/library/at_engine/at_engine.h"
typedef enum
{
#line 44 "c:/users/richard/desktop/workdir/skywire/library/at_engine/at_engine.h"
 AT_CMD_UNKNOWN = 0,
#line 47 "c:/users/richard/desktop/workdir/skywire/library/at_engine/at_engine.h"
 AT_CMD_GET = 1,
#line 50 "c:/users/richard/desktop/workdir/skywire/library/at_engine/at_engine.h"
 AT_CMD_SET = 2,
#line 53 "c:/users/richard/desktop/workdir/skywire/library/at_engine/at_engine.h"
 AT_CMD_TEST = 3,
#line 56 "c:/users/richard/desktop/workdir/skywire/library/at_engine/at_engine.h"
 AT_CMD_EXEC = 4,

}at_type_t;
#line 68 "c:/users/richard/desktop/workdir/skywire/library/at_engine/at_engine.h"
typedef struct
{
#line 72 "c:/users/richard/desktop/workdir/skywire/library/at_engine/at_engine.h"
 uint32_t hash;
#line 75 "c:/users/richard/desktop/workdir/skywire/library/at_engine/at_engine.h"
 uint32_t timeout;
#line 78 "c:/users/richard/desktop/workdir/skywire/library/at_engine/at_engine.h"
 at_cmd_cb getter;
#line 81 "c:/users/richard/desktop/workdir/skywire/library/at_engine/at_engine.h"
 at_cmd_cb setter;
#line 84 "c:/users/richard/desktop/workdir/skywire/library/at_engine/at_engine.h"
 at_cmd_cb tester;
#line 87 "c:/users/richard/desktop/workdir/skywire/library/at_engine/at_engine.h"
 at_cmd_cb executer;

}at_cmd_t;
#line 107 "c:/users/richard/desktop/workdir/skywire/library/at_engine/at_engine.h"
void at_init( at_cmd_cb default_callback, at_write_p default_write,
 uint8_t *buffer_ptr, uint16_t buffer_size );
#line 119 "c:/users/richard/desktop/workdir/skywire/library/at_engine/at_engine.h"
void at_rx( char rx_input );
#line 127 "c:/users/richard/desktop/workdir/skywire/library/at_engine/at_engine.h"
void at_tick( void );
#line 137 "c:/users/richard/desktop/workdir/skywire/library/at_engine/at_engine.h"
void at_cmd_single( char *cmd );
#line 149 "c:/users/richard/desktop/workdir/skywire/library/at_engine/at_engine.h"
void at_cmd_double( char *cmd, char *arg_1 );
#line 162 "c:/users/richard/desktop/workdir/skywire/library/at_engine/at_engine.h"
void at_cmd_triple( char *cmd, char *arg_1, char *arg_2 );
#line 178 "c:/users/richard/desktop/workdir/skywire/library/at_engine/at_engine.h"
void at_cmd_save( char *cmd, uint32_t timeout,
 at_cmd_cb getter, at_cmd_cb setter,
 at_cmd_cb tester, at_cmd_cb executer );
#line 187 "c:/users/richard/desktop/workdir/skywire/library/at_engine/at_engine.h"
void at_process( void );
#line 22 "C:/Users/richard/Desktop/WORKDIR/Skywire/example/PIC/Skywire_PIC.c"
sbit SKYWIRE_EN at LATA0_bit;
sbit SKYWIRE_RST at LATC0_bit;
#line 28 "C:/Users/richard/Desktop/WORKDIR/Skywire/example/PIC/Skywire_PIC.c"
 _Bool  measure_f;
#line 33 "C:/Users/richard/Desktop/WORKDIR/Skywire/example/PIC/Skywire_PIC.c"
uint8_t buffer[ 1024 ] = { 0 };
#line 38 "C:/Users/richard/Desktop/WORKDIR/Skywire/example/PIC/Skywire_PIC.c"
char caller_id[ 20 ] = { 0 };
#line 43 "C:/Users/richard/Desktop/WORKDIR/Skywire/example/PIC/Skywire_PIC.c"
float temperature = 0.0F;

void  SoftUART_Write_Text(char *txt) 
{
 char *ptr = txt;

 while( *ptr )
 Soft_UART_Write( *ptr++ );
}
#line 66 "C:/Users/richard/Desktop/WORKDIR/Skywire/example/PIC/Skywire_PIC.c"
void system_init( void )
{
 TRISA0_bit = 0;
 TRISC0_bit = 0;


 UART1_Init( 115200 );
 Soft_UART_Init( &PORTA, 1, 4, 9600, 0 );
 I2C1_Init( 400000 );
 T1CON = 0x01;
 TMR1IF_bit = 0;
 TMR1H = 0xF0;
 TMR1L = 0x60;
 TMR1IE_bit = 1;
 INTCON = 0xC0;
 RC1IE_bit = 1;
 RC1IF_bit = 0;
 PEIE_bit = 1;
 GIE_bit = 1;
  SoftUART_Write_Text("\r\n_______________________________\r\n System Initialized\r\n") ;
}
#line 91 "C:/Users/richard/Desktop/WORKDIR/Skywire/example/PIC/Skywire_PIC.c"
void skywire_power_on( void )
{
 SKYWIRE_EN = 0;
 Delay_ms( 5000 );
 SKYWIRE_EN = 1;
 Delay_ms( 3000 );
  SoftUART_Write_Text("\r\nSkywire Initialized\r\n") ;
}
#line 103 "C:/Users/richard/Desktop/WORKDIR/Skywire/example/PIC/Skywire_PIC.c"
void rsp_handler( char *rsp )
{
 char tmp[ 25 ] = { 0 };

  SoftUART_Write_Text("Response : \r\n") ;
  SoftUART_Write_Text(rsp) ;
  SoftUART_Write_Text("\r\n") ;
 if( !strncmp( "\r\nRING", rsp, 6 ) )
 measure_f =  1 ;
}
#line 117 "C:/Users/richard/Desktop/WORKDIR/Skywire/example/PIC/Skywire_PIC.c"
void callerid_handler( char *rsp )
{
 char *tmp_s;
 char *tmp_e;

 tmp_s = strchr( rsp, '\"' );
 tmp_e = strchr( tmp_s + 1, '\"' );
 strncpy( caller_id, tmp_s, tmp_e - tmp_s + 1 );
}
#line 130 "C:/Users/richard/Desktop/WORKDIR/Skywire/example/PIC/Skywire_PIC.c"
void measure_temp( void )
{
 int raw_temp;
 uint8_t tmp_data[ 2 ] = { 0x00 };





 I2C1_Start();
 I2C1_Wr( ( 0x48 << 1 ) | 0x00 );
 I2C1_Wr( 0x00 );
 I2C1_Repeated_Start();
 I2C1_Wr( ( 0x48 << 1 ) | 0x01 );
 tmp_data[ 0 ] = I2C1_Rd( 1 );
 tmp_data[ 1 ] = I2C1_Rd( 0 );
 I2C1_Stop();

 raw_temp = ( ( tmp_data[ 0 ] << 8 ) | tmp_data[ 1 ] ) >> 4;

 if( raw_temp & ( 1 << 11 ) )
 raw_temp |= 0xF800;

 temperature = ( float )( raw_temp * 0.0625 );
}
#line 159 "C:/Users/richard/Desktop/WORKDIR/Skywire/example/PIC/Skywire_PIC.c"
void reply_to_caller( void )
{
 char tmp[ 30 ] = { 0 };
 char cmd_content[ 30 ] = { 0 };
 char reply_content[ 256 ] = { 0 };

 strcat( cmd_content, "AT+CMGS=" );
 strcat( cmd_content, caller_id );
 strcat( reply_content, "Temperature : " );
 FloatToStr( temperature, tmp );
 strcat( reply_content, Ltrim( tmp ) );
 strcat( reply_content, " C" );
 at_cmd_double( cmd_content, reply_content );
}


void main()
{
 measure_f =  0 ;
 system_init();
 skywire_power_on();
 at_init( rsp_handler, UART1_Write, buffer, sizeof( buffer ) );
 at_cmd_save( "+CLCC", 1000,  ((void *)0) ,  ((void *)0) ,  ((void *)0) , callerid_handler );
 at_cmd_single( "AT" );
 at_cmd_single( "AT+CSCS=\"GSM\"" );
 at_cmd_single( "AT+CMGF=1" );

 while( 1 )
 {
 at_process();

 if( measure_f )
 {
 measure_temp();
 at_cmd_single( "AT+CLCC" );
 at_cmd_single( "ATH" );
 Delay_ms( 2000 );
 reply_to_caller();
 measure_f =  0 ;
 }
 }
}
#line 205 "C:/Users/richard/Desktop/WORKDIR/Skywire/example/PIC/Skywire_PIC.c"
void interrupt()
{
 if( RC1IF_bit == 1 )
 {
 char tmp = UART1_Read();
 at_rx( tmp );
 }

 if( TMR1IF_bit )
 {
 at_tick();
 TMR1IF_bit = 0;
 TMR1H = 0xF0;
 TMR1L = 0x60;
 }
}
