
_SoftUART_Write_Text:

	MOVF        FARG_SoftUART_Write_Text_txt+0, 0 
	MOVWF       SoftUART_Write_Text_ptr_L0+0 
	MOVF        FARG_SoftUART_Write_Text_txt+1, 0 
	MOVWF       SoftUART_Write_Text_ptr_L0+1 
L_SoftUART_Write_Text0:
	MOVFF       SoftUART_Write_Text_ptr_L0+0, FSR0
	MOVFF       SoftUART_Write_Text_ptr_L0+1, FSR0H
	MOVF        POSTINC0+0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L_SoftUART_Write_Text1
	MOVFF       SoftUART_Write_Text_ptr_L0+0, FSR0
	MOVFF       SoftUART_Write_Text_ptr_L0+1, FSR0H
	MOVF        POSTINC0+0, 0 
	MOVWF       FARG_Soft_UART_Write_udata+0 
	CALL        _Soft_UART_Write+0, 0
	INFSNZ      SoftUART_Write_Text_ptr_L0+0, 1 
	INCF        SoftUART_Write_Text_ptr_L0+1, 1 
	GOTO        L_SoftUART_Write_Text0
L_SoftUART_Write_Text1:
L_end_SoftUART_Write_Text:
	RETURN      0
; end of _SoftUART_Write_Text

_system_init:

	BCF         TRISA0_bit+0, BitPos(TRISA0_bit+0) 
	BCF         TRISC0_bit+0, BitPos(TRISC0_bit+0) 
	MOVLW       34
	MOVWF       SPBRG+0 
	BSF         TXSTA+0, 2, 0
	CALL        _UART1_Init+0, 0
	MOVLW       PORTA+0
	MOVWF       FARG_Soft_UART_Init_port+0 
	MOVLW       hi_addr(PORTA+0)
	MOVWF       FARG_Soft_UART_Init_port+1 
	MOVLW       1
	MOVWF       FARG_Soft_UART_Init_rx_pin+0 
	MOVLW       4
	MOVWF       FARG_Soft_UART_Init_tx_pin+0 
	MOVLW       128
	MOVWF       FARG_Soft_UART_Init_baud_rate+0 
	MOVLW       37
	MOVWF       FARG_Soft_UART_Init_baud_rate+1 
	MOVLW       0
	MOVWF       FARG_Soft_UART_Init_baud_rate+2 
	MOVWF       FARG_Soft_UART_Init_baud_rate+3 
	CLRF        FARG_Soft_UART_Init_inverted+0 
	CALL        _Soft_UART_Init+0, 0
	MOVLW       40
	MOVWF       SSP1ADD+0 
	CALL        _I2C1_Init+0, 0
	MOVLW       1
	MOVWF       T1CON+0 
	BCF         TMR1IF_bit+0, BitPos(TMR1IF_bit+0) 
	MOVLW       240
	MOVWF       TMR1H+0 
	MOVLW       96
	MOVWF       TMR1L+0 
	BSF         TMR1IE_bit+0, BitPos(TMR1IE_bit+0) 
	MOVLW       192
	MOVWF       INTCON+0 
	BSF         RC1IE_bit+0, BitPos(RC1IE_bit+0) 
	BCF         RC1IF_bit+0, BitPos(RC1IF_bit+0) 
	BSF         PEIE_bit+0, BitPos(PEIE_bit+0) 
	BSF         GIE_bit+0, BitPos(GIE_bit+0) 
	MOVLW       ?lstr1_Skywire_PIC+0
	MOVWF       FARG_SoftUART_Write_Text_txt+0 
	MOVLW       hi_addr(?lstr1_Skywire_PIC+0)
	MOVWF       FARG_SoftUART_Write_Text_txt+1 
	CALL        _SoftUART_Write_Text+0, 0
L_end_system_init:
	RETURN      0
; end of _system_init

_skywire_power_on:

	BCF         LATA0_bit+0, BitPos(LATA0_bit+0) 
	MOVLW       2
	MOVWF       R10, 0
	MOVLW       150
	MOVWF       R11, 0
	MOVLW       216
	MOVWF       R12, 0
	MOVLW       8
	MOVWF       R13, 0
L_skywire_power_on2:
	DECFSZ      R13, 1, 1
	BRA         L_skywire_power_on2
	DECFSZ      R12, 1, 1
	BRA         L_skywire_power_on2
	DECFSZ      R11, 1, 1
	BRA         L_skywire_power_on2
	DECFSZ      R10, 1, 1
	BRA         L_skywire_power_on2
	NOP
	BSF         LATA0_bit+0, BitPos(LATA0_bit+0) 
	MOVLW       244
	MOVWF       R11, 0
	MOVLW       130
	MOVWF       R12, 0
	MOVLW       5
	MOVWF       R13, 0
L_skywire_power_on3:
	DECFSZ      R13, 1, 1
	BRA         L_skywire_power_on3
	DECFSZ      R12, 1, 1
	BRA         L_skywire_power_on3
	DECFSZ      R11, 1, 1
	BRA         L_skywire_power_on3
	MOVLW       ?lstr2_Skywire_PIC+0
	MOVWF       FARG_SoftUART_Write_Text_txt+0 
	MOVLW       hi_addr(?lstr2_Skywire_PIC+0)
	MOVWF       FARG_SoftUART_Write_Text_txt+1 
	CALL        _SoftUART_Write_Text+0, 0
L_end_skywire_power_on:
	RETURN      0
; end of _skywire_power_on

_rsp_handler:

	MOVLW       ?lstr3_Skywire_PIC+0
	MOVWF       FARG_SoftUART_Write_Text_txt+0 
	MOVLW       hi_addr(?lstr3_Skywire_PIC+0)
	MOVWF       FARG_SoftUART_Write_Text_txt+1 
	CALL        _SoftUART_Write_Text+0, 0
	MOVF        FARG_rsp_handler_rsp+0, 0 
	MOVWF       FARG_SoftUART_Write_Text_txt+0 
	MOVF        FARG_rsp_handler_rsp+1, 0 
	MOVWF       FARG_SoftUART_Write_Text_txt+1 
	CALL        _SoftUART_Write_Text+0, 0
	MOVLW       ?lstr4_Skywire_PIC+0
	MOVWF       FARG_SoftUART_Write_Text_txt+0 
	MOVLW       hi_addr(?lstr4_Skywire_PIC+0)
	MOVWF       FARG_SoftUART_Write_Text_txt+1 
	CALL        _SoftUART_Write_Text+0, 0
	MOVLW       ?lstr5_Skywire_PIC+0
	MOVWF       FARG_strncmp_s1+0 
	MOVLW       hi_addr(?lstr5_Skywire_PIC+0)
	MOVWF       FARG_strncmp_s1+1 
	MOVF        FARG_rsp_handler_rsp+0, 0 
	MOVWF       FARG_strncmp_s2+0 
	MOVF        FARG_rsp_handler_rsp+1, 0 
	MOVWF       FARG_strncmp_s2+1 
	MOVLW       6
	MOVWF       FARG_strncmp_len+0 
	CALL        _strncmp+0, 0
	MOVF        R0, 0 
	IORWF       R1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_rsp_handler4
	MOVLW       1
	MOVWF       _measure_f+0 
L_rsp_handler4:
L_end_rsp_handler:
	RETURN      0
; end of _rsp_handler

_callerid_handler:

	MOVF        FARG_callerid_handler_rsp+0, 0 
	MOVWF       FARG_strchr_ptr+0 
	MOVF        FARG_callerid_handler_rsp+1, 0 
	MOVWF       FARG_strchr_ptr+1 
	MOVLW       34
	MOVWF       FARG_strchr_chr+0 
	CALL        _strchr+0, 0
	MOVF        R0, 0 
	MOVWF       callerid_handler_tmp_s_L0+0 
	MOVF        R1, 0 
	MOVWF       callerid_handler_tmp_s_L0+1 
	MOVLW       1
	ADDWF       R0, 0 
	MOVWF       FARG_strchr_ptr+0 
	MOVLW       0
	ADDWFC      R1, 0 
	MOVWF       FARG_strchr_ptr+1 
	MOVLW       34
	MOVWF       FARG_strchr_chr+0 
	CALL        _strchr+0, 0
	MOVLW       _caller_id+0
	MOVWF       FARG_strncpy_to+0 
	MOVLW       hi_addr(_caller_id+0)
	MOVWF       FARG_strncpy_to+1 
	MOVF        callerid_handler_tmp_s_L0+0, 0 
	MOVWF       FARG_strncpy_from+0 
	MOVF        callerid_handler_tmp_s_L0+1, 0 
	MOVWF       FARG_strncpy_from+1 
	MOVF        callerid_handler_tmp_s_L0+0, 0 
	SUBWF       R0, 0 
	MOVWF       FARG_strncpy_size+0 
	MOVF        callerid_handler_tmp_s_L0+1, 0 
	SUBWFB      R1, 0 
	MOVWF       FARG_strncpy_size+1 
	INFSNZ      FARG_strncpy_size+0, 1 
	INCF        FARG_strncpy_size+1, 1 
	CALL        _strncpy+0, 0
L_end_callerid_handler:
	RETURN      0
; end of _callerid_handler

_measure_temp:

	CLRF        measure_temp_tmp_data_L0+0 
	CLRF        measure_temp_tmp_data_L0+1 
	CALL        _I2C1_Start+0, 0
	MOVLW       144
	MOVWF       FARG_I2C1_Wr_data_+0 
	CALL        _I2C1_Wr+0, 0
	CLRF        FARG_I2C1_Wr_data_+0 
	CALL        _I2C1_Wr+0, 0
	CALL        _I2C1_Repeated_Start+0, 0
	MOVLW       145
	MOVWF       FARG_I2C1_Wr_data_+0 
	CALL        _I2C1_Wr+0, 0
	MOVLW       1
	MOVWF       FARG_I2C1_Rd_ack+0 
	CALL        _I2C1_Rd+0, 0
	MOVF        R0, 0 
	MOVWF       measure_temp_tmp_data_L0+0 
	CLRF        FARG_I2C1_Rd_ack+0 
	CALL        _I2C1_Rd+0, 0
	MOVF        R0, 0 
	MOVWF       measure_temp_tmp_data_L0+1 
	CALL        _I2C1_Stop+0, 0
	MOVF        measure_temp_tmp_data_L0+0, 0 
	MOVWF       R1 
	CLRF        R0 
	MOVF        measure_temp_tmp_data_L0+1, 0 
	IORWF       R0, 0 
	MOVWF       R4 
	MOVF        R1, 0 
	MOVWF       R5 
	MOVLW       0
	IORWF       R5, 1 
	MOVF        R4, 0 
	MOVWF       R2 
	MOVF        R5, 0 
	MOVWF       R3 
	RRCF        R3, 1 
	RRCF        R2, 1 
	BCF         R3, 7 
	RRCF        R3, 1 
	RRCF        R2, 1 
	BCF         R3, 7 
	RRCF        R3, 1 
	RRCF        R2, 1 
	BCF         R3, 7 
	RRCF        R3, 1 
	RRCF        R2, 1 
	BCF         R3, 7 
	MOVF        R2, 0 
	MOVWF       measure_temp_raw_temp_L0+0 
	MOVF        R3, 0 
	MOVWF       measure_temp_raw_temp_L0+1 
	BTFSS       R3, 3 
	GOTO        L_measure_temp5
	MOVLW       0
	IORWF       measure_temp_raw_temp_L0+0, 1 
	MOVLW       248
	IORWF       measure_temp_raw_temp_L0+1, 1 
L_measure_temp5:
	MOVF        measure_temp_raw_temp_L0+0, 0 
	MOVWF       R0 
	MOVF        measure_temp_raw_temp_L0+1, 0 
	MOVWF       R1 
	CALL        _int2double+0, 0
	MOVLW       0
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	MOVLW       0
	MOVWF       R6 
	MOVLW       123
	MOVWF       R7 
	CALL        _Mul_32x32_FP+0, 0
	MOVF        R0, 0 
	MOVWF       _temperature+0 
	MOVF        R1, 0 
	MOVWF       _temperature+1 
	MOVF        R2, 0 
	MOVWF       _temperature+2 
	MOVF        R3, 0 
	MOVWF       _temperature+3 
L_end_measure_temp:
	RETURN      0
; end of _measure_temp

_reply_to_caller:

	CLRF        reply_to_caller_tmp_L0+0 
	CLRF        reply_to_caller_tmp_L0+1 
	CLRF        reply_to_caller_tmp_L0+2 
	CLRF        reply_to_caller_tmp_L0+3 
	CLRF        reply_to_caller_tmp_L0+4 
	CLRF        reply_to_caller_tmp_L0+5 
	CLRF        reply_to_caller_tmp_L0+6 
	CLRF        reply_to_caller_tmp_L0+7 
	CLRF        reply_to_caller_tmp_L0+8 
	CLRF        reply_to_caller_tmp_L0+9 
	CLRF        reply_to_caller_tmp_L0+10 
	CLRF        reply_to_caller_tmp_L0+11 
	CLRF        reply_to_caller_tmp_L0+12 
	CLRF        reply_to_caller_tmp_L0+13 
	CLRF        reply_to_caller_tmp_L0+14 
	CLRF        reply_to_caller_tmp_L0+15 
	CLRF        reply_to_caller_tmp_L0+16 
	CLRF        reply_to_caller_tmp_L0+17 
	CLRF        reply_to_caller_tmp_L0+18 
	CLRF        reply_to_caller_tmp_L0+19 
	CLRF        reply_to_caller_tmp_L0+20 
	CLRF        reply_to_caller_tmp_L0+21 
	CLRF        reply_to_caller_tmp_L0+22 
	CLRF        reply_to_caller_tmp_L0+23 
	CLRF        reply_to_caller_tmp_L0+24 
	CLRF        reply_to_caller_tmp_L0+25 
	CLRF        reply_to_caller_tmp_L0+26 
	CLRF        reply_to_caller_tmp_L0+27 
	CLRF        reply_to_caller_tmp_L0+28 
	CLRF        reply_to_caller_tmp_L0+29 
	CLRF        reply_to_caller_cmd_content_L0+0 
	CLRF        reply_to_caller_cmd_content_L0+1 
	CLRF        reply_to_caller_cmd_content_L0+2 
	CLRF        reply_to_caller_cmd_content_L0+3 
	CLRF        reply_to_caller_cmd_content_L0+4 
	CLRF        reply_to_caller_cmd_content_L0+5 
	CLRF        reply_to_caller_cmd_content_L0+6 
	CLRF        reply_to_caller_cmd_content_L0+7 
	CLRF        reply_to_caller_cmd_content_L0+8 
	CLRF        reply_to_caller_cmd_content_L0+9 
	CLRF        reply_to_caller_cmd_content_L0+10 
	CLRF        reply_to_caller_cmd_content_L0+11 
	CLRF        reply_to_caller_cmd_content_L0+12 
	CLRF        reply_to_caller_cmd_content_L0+13 
	CLRF        reply_to_caller_cmd_content_L0+14 
	CLRF        reply_to_caller_cmd_content_L0+15 
	CLRF        reply_to_caller_cmd_content_L0+16 
	CLRF        reply_to_caller_cmd_content_L0+17 
	CLRF        reply_to_caller_cmd_content_L0+18 
	CLRF        reply_to_caller_cmd_content_L0+19 
	CLRF        reply_to_caller_cmd_content_L0+20 
	CLRF        reply_to_caller_cmd_content_L0+21 
	CLRF        reply_to_caller_cmd_content_L0+22 
	CLRF        reply_to_caller_cmd_content_L0+23 
	CLRF        reply_to_caller_cmd_content_L0+24 
	CLRF        reply_to_caller_cmd_content_L0+25 
	CLRF        reply_to_caller_cmd_content_L0+26 
	CLRF        reply_to_caller_cmd_content_L0+27 
	CLRF        reply_to_caller_cmd_content_L0+28 
	CLRF        reply_to_caller_cmd_content_L0+29 
	CLRF        reply_to_caller_reply_content_L0+0 
	CLRF        reply_to_caller_reply_content_L0+1 
	CLRF        reply_to_caller_reply_content_L0+2 
	CLRF        reply_to_caller_reply_content_L0+3 
	CLRF        reply_to_caller_reply_content_L0+4 
	CLRF        reply_to_caller_reply_content_L0+5 
	CLRF        reply_to_caller_reply_content_L0+6 
	CLRF        reply_to_caller_reply_content_L0+7 
	CLRF        reply_to_caller_reply_content_L0+8 
	CLRF        reply_to_caller_reply_content_L0+9 
	CLRF        reply_to_caller_reply_content_L0+10 
	CLRF        reply_to_caller_reply_content_L0+11 
	CLRF        reply_to_caller_reply_content_L0+12 
	CLRF        reply_to_caller_reply_content_L0+13 
	CLRF        reply_to_caller_reply_content_L0+14 
	CLRF        reply_to_caller_reply_content_L0+15 
	CLRF        reply_to_caller_reply_content_L0+16 
	CLRF        reply_to_caller_reply_content_L0+17 
	CLRF        reply_to_caller_reply_content_L0+18 
	CLRF        reply_to_caller_reply_content_L0+19 
	CLRF        reply_to_caller_reply_content_L0+20 
	CLRF        reply_to_caller_reply_content_L0+21 
	CLRF        reply_to_caller_reply_content_L0+22 
	CLRF        reply_to_caller_reply_content_L0+23 
	CLRF        reply_to_caller_reply_content_L0+24 
	CLRF        reply_to_caller_reply_content_L0+25 
	CLRF        reply_to_caller_reply_content_L0+26 
	CLRF        reply_to_caller_reply_content_L0+27 
	CLRF        reply_to_caller_reply_content_L0+28 
	CLRF        reply_to_caller_reply_content_L0+29 
	CLRF        reply_to_caller_reply_content_L0+30 
	CLRF        reply_to_caller_reply_content_L0+31 
	CLRF        reply_to_caller_reply_content_L0+32 
	CLRF        reply_to_caller_reply_content_L0+33 
	CLRF        reply_to_caller_reply_content_L0+34 
	CLRF        reply_to_caller_reply_content_L0+35 
	CLRF        reply_to_caller_reply_content_L0+36 
	CLRF        reply_to_caller_reply_content_L0+37 
	CLRF        reply_to_caller_reply_content_L0+38 
	CLRF        reply_to_caller_reply_content_L0+39 
	CLRF        reply_to_caller_reply_content_L0+40 
	CLRF        reply_to_caller_reply_content_L0+41 
	CLRF        reply_to_caller_reply_content_L0+42 
	CLRF        reply_to_caller_reply_content_L0+43 
	CLRF        reply_to_caller_reply_content_L0+44 
	CLRF        reply_to_caller_reply_content_L0+45 
	CLRF        reply_to_caller_reply_content_L0+46 
	CLRF        reply_to_caller_reply_content_L0+47 
	CLRF        reply_to_caller_reply_content_L0+48 
	CLRF        reply_to_caller_reply_content_L0+49 
	CLRF        reply_to_caller_reply_content_L0+50 
	CLRF        reply_to_caller_reply_content_L0+51 
	CLRF        reply_to_caller_reply_content_L0+52 
	CLRF        reply_to_caller_reply_content_L0+53 
	CLRF        reply_to_caller_reply_content_L0+54 
	CLRF        reply_to_caller_reply_content_L0+55 
	CLRF        reply_to_caller_reply_content_L0+56 
	CLRF        reply_to_caller_reply_content_L0+57 
	CLRF        reply_to_caller_reply_content_L0+58 
	CLRF        reply_to_caller_reply_content_L0+59 
	CLRF        reply_to_caller_reply_content_L0+60 
	CLRF        reply_to_caller_reply_content_L0+61 
	CLRF        reply_to_caller_reply_content_L0+62 
	CLRF        reply_to_caller_reply_content_L0+63 
	CLRF        reply_to_caller_reply_content_L0+64 
	CLRF        reply_to_caller_reply_content_L0+65 
	CLRF        reply_to_caller_reply_content_L0+66 
	CLRF        reply_to_caller_reply_content_L0+67 
	CLRF        reply_to_caller_reply_content_L0+68 
	CLRF        reply_to_caller_reply_content_L0+69 
	CLRF        reply_to_caller_reply_content_L0+70 
	CLRF        reply_to_caller_reply_content_L0+71 
	CLRF        reply_to_caller_reply_content_L0+72 
	CLRF        reply_to_caller_reply_content_L0+73 
	CLRF        reply_to_caller_reply_content_L0+74 
	CLRF        reply_to_caller_reply_content_L0+75 
	CLRF        reply_to_caller_reply_content_L0+76 
	CLRF        reply_to_caller_reply_content_L0+77 
	CLRF        reply_to_caller_reply_content_L0+78 
	CLRF        reply_to_caller_reply_content_L0+79 
	CLRF        reply_to_caller_reply_content_L0+80 
	CLRF        reply_to_caller_reply_content_L0+81 
	CLRF        reply_to_caller_reply_content_L0+82 
	CLRF        reply_to_caller_reply_content_L0+83 
	CLRF        reply_to_caller_reply_content_L0+84 
	CLRF        reply_to_caller_reply_content_L0+85 
	CLRF        reply_to_caller_reply_content_L0+86 
	CLRF        reply_to_caller_reply_content_L0+87 
	CLRF        reply_to_caller_reply_content_L0+88 
	CLRF        reply_to_caller_reply_content_L0+89 
	CLRF        reply_to_caller_reply_content_L0+90 
	CLRF        reply_to_caller_reply_content_L0+91 
	CLRF        reply_to_caller_reply_content_L0+92 
	CLRF        reply_to_caller_reply_content_L0+93 
	CLRF        reply_to_caller_reply_content_L0+94 
	CLRF        reply_to_caller_reply_content_L0+95 
	CLRF        reply_to_caller_reply_content_L0+96 
	CLRF        reply_to_caller_reply_content_L0+97 
	CLRF        reply_to_caller_reply_content_L0+98 
	CLRF        reply_to_caller_reply_content_L0+99 
	CLRF        reply_to_caller_reply_content_L0+100 
	CLRF        reply_to_caller_reply_content_L0+101 
	CLRF        reply_to_caller_reply_content_L0+102 
	CLRF        reply_to_caller_reply_content_L0+103 
	CLRF        reply_to_caller_reply_content_L0+104 
	CLRF        reply_to_caller_reply_content_L0+105 
	CLRF        reply_to_caller_reply_content_L0+106 
	CLRF        reply_to_caller_reply_content_L0+107 
	CLRF        reply_to_caller_reply_content_L0+108 
	CLRF        reply_to_caller_reply_content_L0+109 
	CLRF        reply_to_caller_reply_content_L0+110 
	CLRF        reply_to_caller_reply_content_L0+111 
	CLRF        reply_to_caller_reply_content_L0+112 
	CLRF        reply_to_caller_reply_content_L0+113 
	CLRF        reply_to_caller_reply_content_L0+114 
	CLRF        reply_to_caller_reply_content_L0+115 
	CLRF        reply_to_caller_reply_content_L0+116 
	CLRF        reply_to_caller_reply_content_L0+117 
	CLRF        reply_to_caller_reply_content_L0+118 
	CLRF        reply_to_caller_reply_content_L0+119 
	CLRF        reply_to_caller_reply_content_L0+120 
	CLRF        reply_to_caller_reply_content_L0+121 
	CLRF        reply_to_caller_reply_content_L0+122 
	CLRF        reply_to_caller_reply_content_L0+123 
	CLRF        reply_to_caller_reply_content_L0+124 
	CLRF        reply_to_caller_reply_content_L0+125 
	CLRF        reply_to_caller_reply_content_L0+126 
	CLRF        reply_to_caller_reply_content_L0+127 
	CLRF        reply_to_caller_reply_content_L0+128 
	CLRF        reply_to_caller_reply_content_L0+129 
	CLRF        reply_to_caller_reply_content_L0+130 
	CLRF        reply_to_caller_reply_content_L0+131 
	CLRF        reply_to_caller_reply_content_L0+132 
	CLRF        reply_to_caller_reply_content_L0+133 
	CLRF        reply_to_caller_reply_content_L0+134 
	CLRF        reply_to_caller_reply_content_L0+135 
	CLRF        reply_to_caller_reply_content_L0+136 
	CLRF        reply_to_caller_reply_content_L0+137 
	CLRF        reply_to_caller_reply_content_L0+138 
	CLRF        reply_to_caller_reply_content_L0+139 
	CLRF        reply_to_caller_reply_content_L0+140 
	CLRF        reply_to_caller_reply_content_L0+141 
	CLRF        reply_to_caller_reply_content_L0+142 
	CLRF        reply_to_caller_reply_content_L0+143 
	CLRF        reply_to_caller_reply_content_L0+144 
	CLRF        reply_to_caller_reply_content_L0+145 
	CLRF        reply_to_caller_reply_content_L0+146 
	CLRF        reply_to_caller_reply_content_L0+147 
	CLRF        reply_to_caller_reply_content_L0+148 
	CLRF        reply_to_caller_reply_content_L0+149 
	CLRF        reply_to_caller_reply_content_L0+150 
	CLRF        reply_to_caller_reply_content_L0+151 
	CLRF        reply_to_caller_reply_content_L0+152 
	CLRF        reply_to_caller_reply_content_L0+153 
	CLRF        reply_to_caller_reply_content_L0+154 
	CLRF        reply_to_caller_reply_content_L0+155 
	CLRF        reply_to_caller_reply_content_L0+156 
	CLRF        reply_to_caller_reply_content_L0+157 
	CLRF        reply_to_caller_reply_content_L0+158 
	CLRF        reply_to_caller_reply_content_L0+159 
	CLRF        reply_to_caller_reply_content_L0+160 
	CLRF        reply_to_caller_reply_content_L0+161 
	CLRF        reply_to_caller_reply_content_L0+162 
	CLRF        reply_to_caller_reply_content_L0+163 
	CLRF        reply_to_caller_reply_content_L0+164 
	CLRF        reply_to_caller_reply_content_L0+165 
	CLRF        reply_to_caller_reply_content_L0+166 
	CLRF        reply_to_caller_reply_content_L0+167 
	CLRF        reply_to_caller_reply_content_L0+168 
	CLRF        reply_to_caller_reply_content_L0+169 
	CLRF        reply_to_caller_reply_content_L0+170 
	CLRF        reply_to_caller_reply_content_L0+171 
	CLRF        reply_to_caller_reply_content_L0+172 
	CLRF        reply_to_caller_reply_content_L0+173 
	CLRF        reply_to_caller_reply_content_L0+174 
	CLRF        reply_to_caller_reply_content_L0+175 
	CLRF        reply_to_caller_reply_content_L0+176 
	CLRF        reply_to_caller_reply_content_L0+177 
	CLRF        reply_to_caller_reply_content_L0+178 
	CLRF        reply_to_caller_reply_content_L0+179 
	CLRF        reply_to_caller_reply_content_L0+180 
	CLRF        reply_to_caller_reply_content_L0+181 
	CLRF        reply_to_caller_reply_content_L0+182 
	CLRF        reply_to_caller_reply_content_L0+183 
	CLRF        reply_to_caller_reply_content_L0+184 
	CLRF        reply_to_caller_reply_content_L0+185 
	CLRF        reply_to_caller_reply_content_L0+186 
	CLRF        reply_to_caller_reply_content_L0+187 
	CLRF        reply_to_caller_reply_content_L0+188 
	CLRF        reply_to_caller_reply_content_L0+189 
	CLRF        reply_to_caller_reply_content_L0+190 
	CLRF        reply_to_caller_reply_content_L0+191 
	CLRF        reply_to_caller_reply_content_L0+192 
	CLRF        reply_to_caller_reply_content_L0+193 
	CLRF        reply_to_caller_reply_content_L0+194 
	CLRF        reply_to_caller_reply_content_L0+195 
	CLRF        reply_to_caller_reply_content_L0+196 
	CLRF        reply_to_caller_reply_content_L0+197 
	CLRF        reply_to_caller_reply_content_L0+198 
	CLRF        reply_to_caller_reply_content_L0+199 
	CLRF        reply_to_caller_reply_content_L0+200 
	CLRF        reply_to_caller_reply_content_L0+201 
	CLRF        reply_to_caller_reply_content_L0+202 
	CLRF        reply_to_caller_reply_content_L0+203 
	CLRF        reply_to_caller_reply_content_L0+204 
	CLRF        reply_to_caller_reply_content_L0+205 
	CLRF        reply_to_caller_reply_content_L0+206 
	CLRF        reply_to_caller_reply_content_L0+207 
	CLRF        reply_to_caller_reply_content_L0+208 
	CLRF        reply_to_caller_reply_content_L0+209 
	CLRF        reply_to_caller_reply_content_L0+210 
	CLRF        reply_to_caller_reply_content_L0+211 
	CLRF        reply_to_caller_reply_content_L0+212 
	CLRF        reply_to_caller_reply_content_L0+213 
	CLRF        reply_to_caller_reply_content_L0+214 
	CLRF        reply_to_caller_reply_content_L0+215 
	CLRF        reply_to_caller_reply_content_L0+216 
	CLRF        reply_to_caller_reply_content_L0+217 
	CLRF        reply_to_caller_reply_content_L0+218 
	CLRF        reply_to_caller_reply_content_L0+219 
	CLRF        reply_to_caller_reply_content_L0+220 
	CLRF        reply_to_caller_reply_content_L0+221 
	CLRF        reply_to_caller_reply_content_L0+222 
	CLRF        reply_to_caller_reply_content_L0+223 
	CLRF        reply_to_caller_reply_content_L0+224 
	CLRF        reply_to_caller_reply_content_L0+225 
	CLRF        reply_to_caller_reply_content_L0+226 
	CLRF        reply_to_caller_reply_content_L0+227 
	CLRF        reply_to_caller_reply_content_L0+228 
	CLRF        reply_to_caller_reply_content_L0+229 
	CLRF        reply_to_caller_reply_content_L0+230 
	CLRF        reply_to_caller_reply_content_L0+231 
	CLRF        reply_to_caller_reply_content_L0+232 
	CLRF        reply_to_caller_reply_content_L0+233 
	CLRF        reply_to_caller_reply_content_L0+234 
	CLRF        reply_to_caller_reply_content_L0+235 
	CLRF        reply_to_caller_reply_content_L0+236 
	CLRF        reply_to_caller_reply_content_L0+237 
	CLRF        reply_to_caller_reply_content_L0+238 
	CLRF        reply_to_caller_reply_content_L0+239 
	CLRF        reply_to_caller_reply_content_L0+240 
	CLRF        reply_to_caller_reply_content_L0+241 
	CLRF        reply_to_caller_reply_content_L0+242 
	CLRF        reply_to_caller_reply_content_L0+243 
	CLRF        reply_to_caller_reply_content_L0+244 
	CLRF        reply_to_caller_reply_content_L0+245 
	CLRF        reply_to_caller_reply_content_L0+246 
	CLRF        reply_to_caller_reply_content_L0+247 
	CLRF        reply_to_caller_reply_content_L0+248 
	CLRF        reply_to_caller_reply_content_L0+249 
	CLRF        reply_to_caller_reply_content_L0+250 
	CLRF        reply_to_caller_reply_content_L0+251 
	CLRF        reply_to_caller_reply_content_L0+252 
	CLRF        reply_to_caller_reply_content_L0+253 
	CLRF        reply_to_caller_reply_content_L0+254 
	CLRF        reply_to_caller_reply_content_L0+255 
	MOVLW       reply_to_caller_cmd_content_L0+0
	MOVWF       FARG_strcat_to+0 
	MOVLW       hi_addr(reply_to_caller_cmd_content_L0+0)
	MOVWF       FARG_strcat_to+1 
	MOVLW       ?lstr6_Skywire_PIC+0
	MOVWF       FARG_strcat_from+0 
	MOVLW       hi_addr(?lstr6_Skywire_PIC+0)
	MOVWF       FARG_strcat_from+1 
	CALL        _strcat+0, 0
	MOVLW       reply_to_caller_cmd_content_L0+0
	MOVWF       FARG_strcat_to+0 
	MOVLW       hi_addr(reply_to_caller_cmd_content_L0+0)
	MOVWF       FARG_strcat_to+1 
	MOVLW       _caller_id+0
	MOVWF       FARG_strcat_from+0 
	MOVLW       hi_addr(_caller_id+0)
	MOVWF       FARG_strcat_from+1 
	CALL        _strcat+0, 0
	MOVLW       reply_to_caller_reply_content_L0+0
	MOVWF       FARG_strcat_to+0 
	MOVLW       hi_addr(reply_to_caller_reply_content_L0+0)
	MOVWF       FARG_strcat_to+1 
	MOVLW       ?lstr7_Skywire_PIC+0
	MOVWF       FARG_strcat_from+0 
	MOVLW       hi_addr(?lstr7_Skywire_PIC+0)
	MOVWF       FARG_strcat_from+1 
	CALL        _strcat+0, 0
	MOVF        _temperature+0, 0 
	MOVWF       FARG_FloatToStr_fnum+0 
	MOVF        _temperature+1, 0 
	MOVWF       FARG_FloatToStr_fnum+1 
	MOVF        _temperature+2, 0 
	MOVWF       FARG_FloatToStr_fnum+2 
	MOVF        _temperature+3, 0 
	MOVWF       FARG_FloatToStr_fnum+3 
	MOVLW       reply_to_caller_tmp_L0+0
	MOVWF       FARG_FloatToStr_str+0 
	MOVLW       hi_addr(reply_to_caller_tmp_L0+0)
	MOVWF       FARG_FloatToStr_str+1 
	CALL        _FloatToStr+0, 0
	MOVLW       reply_to_caller_tmp_L0+0
	MOVWF       FARG_Ltrim_string+0 
	MOVLW       hi_addr(reply_to_caller_tmp_L0+0)
	MOVWF       FARG_Ltrim_string+1 
	CALL        _Ltrim+0, 0
	MOVF        R0, 0 
	MOVWF       FARG_strcat_from+0 
	MOVF        R1, 0 
	MOVWF       FARG_strcat_from+1 
	MOVLW       reply_to_caller_reply_content_L0+0
	MOVWF       FARG_strcat_to+0 
	MOVLW       hi_addr(reply_to_caller_reply_content_L0+0)
	MOVWF       FARG_strcat_to+1 
	CALL        _strcat+0, 0
	MOVLW       reply_to_caller_reply_content_L0+0
	MOVWF       FARG_strcat_to+0 
	MOVLW       hi_addr(reply_to_caller_reply_content_L0+0)
	MOVWF       FARG_strcat_to+1 
	MOVLW       ?lstr8_Skywire_PIC+0
	MOVWF       FARG_strcat_from+0 
	MOVLW       hi_addr(?lstr8_Skywire_PIC+0)
	MOVWF       FARG_strcat_from+1 
	CALL        _strcat+0, 0
	MOVLW       reply_to_caller_cmd_content_L0+0
	MOVWF       FARG_at_cmd_double_cmd+0 
	MOVLW       hi_addr(reply_to_caller_cmd_content_L0+0)
	MOVWF       FARG_at_cmd_double_cmd+1 
	MOVLW       reply_to_caller_reply_content_L0+0
	MOVWF       FARG_at_cmd_double_arg_1+0 
	MOVLW       hi_addr(reply_to_caller_reply_content_L0+0)
	MOVWF       FARG_at_cmd_double_arg_1+1 
	CALL        _at_cmd_double+0, 0
L_end_reply_to_caller:
	RETURN      0
; end of _reply_to_caller

_main:

	CLRF        _measure_f+0 
	CALL        _system_init+0, 0
	CALL        _skywire_power_on+0, 0
	MOVLW       _rsp_handler+0
	MOVWF       FARG_at_init_default_callback+0 
	MOVLW       hi_addr(_rsp_handler+0)
	MOVWF       FARG_at_init_default_callback+1 
	MOVLW       FARG_rsp_handler_rsp+0
	MOVWF       FARG_at_init_default_callback+2 
	MOVLW       hi_addr(FARG_rsp_handler_rsp+0)
	MOVWF       FARG_at_init_default_callback+3 
	MOVLW       _UART1_Write+0
	MOVWF       FARG_at_init_default_write+0 
	MOVLW       hi_addr(_UART1_Write+0)
	MOVWF       FARG_at_init_default_write+1 
	MOVLW       FARG_UART1_Write_data_+0
	MOVWF       FARG_at_init_default_write+2 
	MOVLW       hi_addr(FARG_UART1_Write_data_+0)
	MOVWF       FARG_at_init_default_write+3 
	MOVLW       _buffer+0
	MOVWF       FARG_at_init_buffer_ptr+0 
	MOVLW       hi_addr(_buffer+0)
	MOVWF       FARG_at_init_buffer_ptr+1 
	MOVLW       0
	MOVWF       FARG_at_init_buffer_size+0 
	MOVLW       4
	MOVWF       FARG_at_init_buffer_size+1 
	CALL        _at_init+0, 0
	MOVLW       ?lstr9_Skywire_PIC+0
	MOVWF       FARG_at_cmd_save_cmd+0 
	MOVLW       hi_addr(?lstr9_Skywire_PIC+0)
	MOVWF       FARG_at_cmd_save_cmd+1 
	MOVLW       232
	MOVWF       FARG_at_cmd_save_timeout+0 
	MOVLW       3
	MOVWF       FARG_at_cmd_save_timeout+1 
	MOVLW       0
	MOVWF       FARG_at_cmd_save_timeout+2 
	MOVWF       FARG_at_cmd_save_timeout+3 
	CLRF        FARG_at_cmd_save_getter+0 
	CLRF        FARG_at_cmd_save_getter+1 
	CLRF        FARG_at_cmd_save_getter+2 
	CLRF        FARG_at_cmd_save_getter+3 
	CLRF        FARG_at_cmd_save_setter+0 
	CLRF        FARG_at_cmd_save_setter+1 
	CLRF        FARG_at_cmd_save_setter+2 
	CLRF        FARG_at_cmd_save_setter+3 
	CLRF        FARG_at_cmd_save_tester+0 
	CLRF        FARG_at_cmd_save_tester+1 
	CLRF        FARG_at_cmd_save_tester+2 
	CLRF        FARG_at_cmd_save_tester+3 
	MOVLW       _callerid_handler+0
	MOVWF       FARG_at_cmd_save_executer+0 
	MOVLW       hi_addr(_callerid_handler+0)
	MOVWF       FARG_at_cmd_save_executer+1 
	MOVLW       FARG_callerid_handler_rsp+0
	MOVWF       FARG_at_cmd_save_executer+2 
	MOVLW       hi_addr(FARG_callerid_handler_rsp+0)
	MOVWF       FARG_at_cmd_save_executer+3 
	CALL        _at_cmd_save+0, 0
	MOVLW       ?lstr10_Skywire_PIC+0
	MOVWF       FARG_at_cmd_single_cmd+0 
	MOVLW       hi_addr(?lstr10_Skywire_PIC+0)
	MOVWF       FARG_at_cmd_single_cmd+1 
	CALL        _at_cmd_single+0, 0
	MOVLW       ?lstr11_Skywire_PIC+0
	MOVWF       FARG_at_cmd_single_cmd+0 
	MOVLW       hi_addr(?lstr11_Skywire_PIC+0)
	MOVWF       FARG_at_cmd_single_cmd+1 
	CALL        _at_cmd_single+0, 0
	MOVLW       ?lstr12_Skywire_PIC+0
	MOVWF       FARG_at_cmd_single_cmd+0 
	MOVLW       hi_addr(?lstr12_Skywire_PIC+0)
	MOVWF       FARG_at_cmd_single_cmd+1 
	CALL        _at_cmd_single+0, 0
L_main6:
	CALL        _at_process+0, 0
	MOVF        _measure_f+0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L_main8
	CALL        _measure_temp+0, 0
	MOVLW       ?lstr13_Skywire_PIC+0
	MOVWF       FARG_at_cmd_single_cmd+0 
	MOVLW       hi_addr(?lstr13_Skywire_PIC+0)
	MOVWF       FARG_at_cmd_single_cmd+1 
	CALL        _at_cmd_single+0, 0
	MOVLW       ?lstr14_Skywire_PIC+0
	MOVWF       FARG_at_cmd_single_cmd+0 
	MOVLW       hi_addr(?lstr14_Skywire_PIC+0)
	MOVWF       FARG_at_cmd_single_cmd+1 
	CALL        _at_cmd_single+0, 0
	MOVLW       163
	MOVWF       R11, 0
	MOVLW       87
	MOVWF       R12, 0
	MOVLW       2
	MOVWF       R13, 0
L_main9:
	DECFSZ      R13, 1, 1
	BRA         L_main9
	DECFSZ      R12, 1, 1
	BRA         L_main9
	DECFSZ      R11, 1, 1
	BRA         L_main9
	NOP
	CALL        _reply_to_caller+0, 0
	CLRF        _measure_f+0 
L_main8:
	GOTO        L_main6
L_end_main:
	GOTO        $+0
; end of _main

_interrupt:

	BTFSS       RC1IF_bit+0, BitPos(RC1IF_bit+0) 
	GOTO        L_interrupt10
	CALL        _UART1_Read+0, 0
	MOVF        R0, 0 
	MOVWF       FARG_at_rx_rx_input+0 
	CALL        _at_rx+0, 0
L_interrupt10:
	BTFSS       TMR1IF_bit+0, BitPos(TMR1IF_bit+0) 
	GOTO        L_interrupt11
	CALL        _at_tick+0, 0
	BCF         TMR1IF_bit+0, BitPos(TMR1IF_bit+0) 
	MOVLW       240
	MOVWF       TMR1H+0 
	MOVLW       96
	MOVWF       TMR1L+0 
L_interrupt11:
L_end_interrupt:
L__interrupt21:
	RETFIE      1
; end of _interrupt
